###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk
import gobject
import stock
from context_local import *
from context_web import *


class ListenContext(gtk.VBox):
    def __init__(self,media_organizer):
        gtk.VBox.__init__(self,False,0)

        self.media_organizer = media_organizer

        self.home_label = gtk.HBox(False,6)
        self.home_label.pack_start(gtk.image_new_from_stock(gtk.STOCK_HOME,gtk.ICON_SIZE_BUTTON),False,False)
        self.home_label.pack_start(gtk.Label(_("Home")))
        self.home_label.show_all()
        self.home_widget = ListenHome(self.media_organizer)

        self.information_label = gtk.HBox(False,6)
        self.information_label.pack_start(gtk.image_new_from_stock(gtk.STOCK_INFO,gtk.ICON_SIZE_BUTTON),False,False)
        self.information_label.pack_start(gtk.Label(_("Current")))
        self.information_label.show_all()
        self.information_widget = ListenInformation(self.media_organizer)

        self.lyrics_label = gtk.HBox(False,6)
        self.lyrics_label.pack_start(gtk.image_new_from_stock(gtk.STOCK_EDIT,gtk.ICON_SIZE_BUTTON),False,False)
        self.lyrics_label.pack_start(gtk.Label(_("Lyrics")))
        self.lyrics_label.show_all()
        self.lyrics_widget = ListenLyrics(self.media_organizer)

        self.wikipedia_label = gtk.HBox(False,6)
        self.wikipedia_label.pack_start(gtk.image_new_from_stock(stock.WIKIPEDIA,gtk.ICON_SIZE_BUTTON),False,False)
        self.wikipedia_label.pack_start(gtk.Label(_("Wikipedia")))
        self.wikipedia_label.show_all()
        self.wikipedia_widget = ListenWikiPedia(self.media_organizer)


        self.notebook = gtk.Notebook()
        self.notebook.set_property("show-border",False)
        self.notebook.append_page(self.home_widget,self.home_label)
        self.notebook.append_page(self.information_widget,self.information_label)
        self.notebook.append_page(self.lyrics_widget,self.lyrics_label)
        self.notebook.append_page(self.wikipedia_widget,self.wikipedia_label)



        self.pack_start(self.notebook)

