###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###


import gobject
import gtk
from time import time
import os, sys

from db_manager import DBManager
from song import *


class ListenFileInspector( gobject.GObject ):
    def __init__( self ):
        gobject.GObject.__init__( self )
        self.verbose = False
        self.total = 0
        self.courant = 0
        self.ready = False
        self.current_info = {}

    def is_ready(self):
        return self.ready

    def get_info(self):
        return self.current_info;

    def check_db(self):
        debut = time()
        self.ready = True
        songs = DBManager.get_all_songs()
        self.total = len( songs )
        self.courant = 0
        self.current_info["total"] = self.total
        print "NB FILE TO SCAN: %d"%self.total
        for song in songs:
            self.current_info["num"] = self.courant
            self.current_info["file"] = song.get_property("uri")
            self.courant +=1
            if os.path.exists(song.get_path())==False:
                #print (utils.fsencode(utils.get_path(song["uri"])))
                DBManager.delete_song(song)

            #Force update gtk because sqlite is not thread
            #And here i must work on the main DBManager instance
            while gtk.events_pending(): gtk.main_iteration()
        self.current_info = None
        fin = time()
        duree = fin-debut
        print "SCAN TIME: %d s"%duree

    def parse_directory( self, dirs ):

        def parse_dir(dir,last_m_fn="",last_path_fn=""):
            local_list = []
            for path, dnames, fnames in os.walk( dir ):
                #print dnames
                for fn in fnames:
                    #print fnames
                    while gtk.events_pending(): gtk.main_iteration()
                    if fn.rfind( "." )>0 and fn[fn.rfind( "." ):] in READ_EXTENTIONS:
                        # don't re-resolve this path every time
                        if last_path_fn == path+fn:
                            m_fm = last_m_fn
                        else:
                            path_fn = os.path.join( path, fn )
                            m_fn = os.path.realpath( path_fn )
                            last_m_fn = m_fn
                            last_path_fn = path+fn
                        local_list.append( m_fn )
                for dn in dnames:
                    path_dn = os.path.join( path, dn )
                    if os.path.islink(path_dn):
                        d_dn = os.path.realpath( path_dn )
                        local_list.extend(parse_dir(d_dn,last_m_fn,last_path_fn))

            return local_list

        debut = time()
        d = os.path.expanduser( dirs )

        list = parse_dir(d)

        self.ready = True
        self.total = len( list )
        self.courant = 0
        self.current_info["total"] = self.total
        print "NB FILE TO LOAD %d"%self.total
        for file in list:
            self.current_info["num"] = self.courant
            self.current_info["file"] = file
            self.courant +=1
            song = DBManager.get_song_by_uri("file://"+file)
            while gtk.events_pending(): gtk.main_iteration()
        self.current_info = None
        fin = time()
        duree = fin-debut
        print "LOADING TIME: %d s"%duree



    def debug( self, str ):
        if self.verbose : print "ListenFileInspector() : "+str

