###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk
import pango
import stock
import egg.trayicon
import config
import os
import utils
import amazon
import urllib
import gobject

def get_scrolled_window(widget):
        scroll = gtk.ScrolledWindow()
        scroll.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        scroll.add(widget)
        scroll.set_shadow_type(gtk.SHADOW_IN)
        return scroll

class WindowBase(gtk.Dialog):

    def __init__(self,title="",image_filename=None,bouton = (gtk.STOCK_OK, gtk.RESPONSE_ACCEPT,
                          gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL) ):

        gtk.Dialog.__init__(self,title,None,
                 gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                     bouton
                 )

        self.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        self.set_resize_mode(False)
        self.box_contenu = gtk.VBox(False,12)
        self.set_modal(True)
        self.set_property("skip-taskbar-hint",True)
        self.label_heading = gtk.Label("<span size=\"large\"><b>"+title+"</b></span>")
        self.label_heading.set_alignment(0,0.5)
        self.label_heading.set_use_markup(True)
        self.box_contenu.pack_start(self.label_heading,False,False)
        #self.box_contenu.set_border_width(12)

        image = gtk.Image()
        image.set_from_file(image_filename)
        image.set_alignment(0,0)
        hbox = gtk.HBox(False,12)
        hbox.pack_start(image,False,False)
        hbox.pack_start(self.box_contenu,True,True)
        hbox.set_border_width(12)
        self.vbox.pack_start(hbox,False,False)
        self.set_resizable(False)

    def add_widget(self,widget):
        self.box_contenu.pack_start(widget,False,False)

class AmazonWindow(WindowBase):
    def __init__(self,song):
        WindowBase.__init__(self,_("Search a album cover"),config.PIXMAP_DIR+"listen_cover_color.png",(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))

        default_search = song.get_album_art_search_str()

        self.song = song
        self.entry = gtk.Entry()
        self.entry.set_text(default_search.replace("+"," "))
        self.entry.set_size_request(300,-1)
        self.entry.connect("activate",lambda btn: self.on_search(btn))

        btn_search = gtk.Button(stock=gtk.STOCK_FIND)
        btn_search.connect("clicked",self.on_search)
        hbox = gtk.HBox(False,12)
        hbox.pack_start(self.entry,True,True)
        hbox.pack_start(btn_search,False,False)

        self.box_resultat = gtk.Table(4,2)

        vbox = gtk.VBox(False,0)
        vbox.pack_start(hbox,False,False)
        vbox.pack_start(self.box_resultat,False,False)
        self.add_widget(vbox)

        #gobject.timeout_add(100,self.on_search)
        #self.on_search()

        self.show_all()
        reponse = self.run()
        if reponse == gtk.RESPONSE_CANCEL:
            self.destroy()

    def on_search(self,btn=None):
        art = self.entry.get_text()
        art = utils.filtre_info_song(art).encode('utf-8')

        self.box_resultat.foreach(self.box_resultat.remove)
        amazon.setLicense("0RKH4ZH1JCFZHMND91G2")
        try:
            bags = amazon.searchByKeyword(art,type="lite", product_line="music")
        except:
            self.box_resultat.resize(1,1)
            self.box_resultat.attach(gtk.Label(_("No result for this query")), 0, 1, 0, 1)
            pass
        else:
            tmp_dir = "/tmp/listen/cover"
            if not os.path.exists(tmp_dir):
                os.makedirs(tmp_dir)
            i = 0
            height= int(round(len(bags)/2,1))
            if len(bags)%2!=0: height += 1
            if height>8 : height=8
            gobject.idle_add(self.box_resultat.resize,height,2)
            top_attach = 0
            left_attach = 0
            for bag in bags:
                if i>16:
                    break;
                image_path = tmp_dir+"/%d.jpg"%i
                if  os.path.exists(image_path):
                    os.unlink(image_path)
                res = urllib.urlretrieve(bag.ImageUrlSmall, image_path)

                pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(image_path,40,40)
                image = gtk.Image()
                image.set_from_pixbuf(pixbuf)
                image.set_size_request(40,40)
                label = gtk.Label()
                artists = bag.Artists.Artist
                if isinstance(artists,list):
                    artists = artists[0]
                label.set_markup("<b>"+bag.ProductName+"</b>\n"+artists)
                label.set_property("ellipsize",pango.ELLIPSIZE_END)
                label.set_alignment(0,0.5)
                box= gtk.HBox(False,6)
                box.pack_start(image,False,False)
                box.pack_start(label,True,True)

                btn_album_art = gtk.Button()#"test-%d"%i)
                btn_album_art.set_alignment(0.5,0.5)
                btn_album_art.connect("clicked",self.on_album_art_clicked,image_path)
                btn_album_art.set_relief(gtk.RELIEF_NONE)
                btn_album_art.add(box)
                right_attach = left_attach+1
                bottom_attach = top_attach+1
                self.box_resultat.attach(btn_album_art, left_attach, right_attach, top_attach, bottom_attach)
                i += 1
                if i%2==0:
                    top_attach += 1
                    left_attach = 0
                else:
                    left_attach += 1
                #self.box_resultat.pack_start(btn_album_art,False,False)

        self.show_all()

    def on_album_art_clicked(self,btn,image_path):
        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(image_path,75,75)
        self.song.remove_album_art()
        new_file = self.song.get_album_art_path()
        if os.path.exists(new_file):
             os.unlink(new_file)
        pixbuf.save(new_file, "jpeg", {"quality":"85"})
        del pixbuf
        self.destroy()


class WindowWarning(WindowBase):
    def __init__(self,msg):
        WindowBase.__init__(self,"Listen warning",config.PIXMAP_DIR+"playlist_big.png",(gtk.STOCK_CLOSE, gtk.RESPONSE_CANCEL) )

        self.label_heading.set_markup(msg)
        self.set_property("skip-taskbar-hint",True)
        self.set_property('has-separator',False)
        self.show_all()
        self.run()
        self.destroy()

class trayicon:
    def __init__(self,player):

        self.player = player
        self.window = self.player.get_toplevel()
        self.player.connect("player-action",self.player_action_cb)

        self.tray = egg.trayicon.TrayIcon("Listen")

        self.eventbox = gtk.EventBox()
        self.tray.add(self.eventbox)

        self.eventbox.connect("button_press_event", self.on_button_press_event )
        self.eventbox.connect("enter-notify-event", self.on_mouse_over)
        self.eventbox.connect("leave-notify-event", self.on_mouse_out)

        self.icone = gtk.Image()
        self.icone.set_from_file(config.PIXMAP_DIR+"/listen_tray.png")
        self.eventbox.add(self.icone)

        #self.menu = menu_trayicon(self.player)
        self.__pos = self.window.get_position()

        self.tray.show_all()

        menu_ui = """
        <ui>
            <popup name="TrayIconMenu">
              <menuitem name="play" action="play"/>
              <menuitem name="pause" action="pause"/>
              <menuitem name="next" action="next"/>
              <menuitem name="previous" action="previous"/>
              <separator/>
              <menuitem name="quit" action="quit"/>
            </popup>
        </ui>
        """
        self.uimanager = gtk.UIManager()
        self.uimanager.add_ui_from_string(menu_ui)
        accelgroup = self.uimanager.get_accel_group()

        actiongroup = gtk.ActionGroup('Listen')
        actiongroup.add_actions([('play', gtk.STOCK_MEDIA_PLAY, _('_Play'), None,
                                         _('Play'), self.action_tray)])
        actiongroup.add_actions([('pause', gtk.STOCK_MEDIA_PAUSE, _('_Pause'), None,
                                         _('Pause'), self.action_tray)])
        actiongroup.add_actions([('next', gtk.STOCK_MEDIA_NEXT, _('_Next'), None,
                                         _('Next'), self.action_tray)])
        actiongroup.add_actions([('previous', gtk.STOCK_MEDIA_PREVIOUS, _('_Previous'), None,
                                         _('Previous'),self.action_tray)])
        actiongroup.add_actions([('quit', gtk.STOCK_QUIT, _('_Quit'), None,
                          _('Quit Listen'), self.action_tray)])

        self.uimanager.insert_action_group(actiongroup, 1)
        #self.add_accel_group(accelgroup)
        self.pause = self.uimanager.get_action("/TrayIconMenu/pause")
        self.pause.set_visible(False)
        self.play =  self.uimanager.get_action("/TrayIconMenu/play")
        self.menu = self.uimanager.get_widget("/TrayIconMenu")
        self.menu.connect("selection-done",self.on_selection_done)
        self.show_menu=False

    def on_mouse_over(self,widget,event=None):
        if self.show_menu == False and self.player.current_info!=None:
            filename = self.player.current_info.get_album_art()
            self.player.osd.show_osd(self.player.current_info,filename)

    def on_mouse_out(self,widget,event=None):
        self.player.osd.hide_osd(None,None)

    def on_selection_done(self,widget):
        self.show_menu=False

    def action_tray(self,btn):
        name = btn.get_name()
        if name == "quit":
            self.window.on_quit(None)
        if name == "play":
            self.player.btn_play.set_active(True)
        if name == "pause":
            self.player.btn_play.set_active(False)
        if name == "next":
            self.player.btn_next.clicked()
        if name == "previous":
            self.player.btn_previous.clicked()


    def player_action_cb(self,widget,action):
        if action=="pause":
            self.pause.set_visible(False)
            self.play.set_visible(True)
        else:
            self.pause.set_visible(True)
            self.play.set_visible(False)



    def on_button_press_event(self , widget, event):
        if event.button == 1:
            if self.window.get_property('visible'):
                if self.window.is_active():
                    self.cacher()
                else:
                    self.window.present()
            else:
                self.montrer()
        if event.button == 3:
            self.show_menu=True
            self.player.osd.hide_osd(None,None)
            self.menu.popup(None,None,None,event.button,event.time)


    def cacher(self):
        self.__pos = self.window.get_position()
        event = self.window.window.get_state()
        if event == gtk.gdk.WINDOW_STATE_MAXIMIZED:
            config.set("setting","window_state","maximized")
        else:
            config.set("setting","window_state","normal")
        self.window.hide_all()

    def montrer(self):
        self.window.move(*self.__pos)
        window_state = config.get("setting","window_state")
        if window_state == "maximized" :
            self.window.maximize()
        if window_state == "normal":
            self.window.unmaximize()
        self.window.show_all()

class PopupSlider(gtk.EventBox):
    # Based on the Rhythmbox volume control button; thanks to Colin Walters,
    # Richard Hult, Michael Fulbright, Miguel de Icaza, and Federico Mena.

    def __init__(self, child=None, adj=None, req=None):
        gtk.EventBox.__init__(self)
        button = gtk.Button()
        #button = self.player.button.btn_volume

        if child: button.add(child)
        self.add(button)
        button.connect('clicked', self.__clicked)
        self.show_all()

        window = self.__window = gtk.Window(gtk.WINDOW_POPUP)
        self.__adj = adj or self._adj

        frame = gtk.Frame()
        frame.set_border_width(0)
        frame.set_shadow_type(gtk.SHADOW_OUT)

        hscale = self.Scale(self.__adj)
        hscale.set_size_request(*(req or self._req))
        window.connect('button-press-event', self.__button)
        hscale.connect('key-press-event', self.__key)
        hscale.set_draw_value(False)
        hscale.set_update_policy(gtk.UPDATE_CONTINUOUS)
        self.scale = hscale
        window.add(frame)
        frame.add(hscale)
        self.connect('scroll-event', self.__scroll, hscale)
        self.__window.connect('scroll-event', self.__window_scroll)
        self.scale.connect_object('scroll-event', self.emit, 'scroll-event')

    def __window_scroll(self, window, event):
        self.emit('scroll-event', event)

    def _move_to(self, x, y, w, h, ww, wh, pad=3):
        raise NotImplementedError


    def __clicked(self, button):
        if self.__window.get_property('visible'): return
        self.__window.child.show_all()
        req = self.__window.size_request()
        x, y = self.child.window.get_origin()
        w, h = self.child.window.get_size()
        ww, wh = self.__window.child.parent.get_size()
        sx, sy = self._move_to(x, y, w, h, ww, wh, pad=3)
        self.__window.move(sx, sy)
        self.__window.show()
        self.__window.grab_focus()
        self.__window.grab_add()
        pointer = gtk.gdk.pointer_grab(
            self.__window.window, True,
            gtk.gdk.BUTTON_PRESS_MASK |
            gtk.gdk.BUTTON_RELEASE_MASK |
            gtk.gdk.BUTTON_MOTION_MASK |
            gtk.gdk.POINTER_MOTION_MASK |
            gtk.gdk.SCROLL_MASK, None, None, gtk.get_current_event_time())
        keyboard = gtk.gdk.keyboard_grab(
            self.__window.window, True, gtk.get_current_event_time())

        if pointer != gtk.gdk.GRAB_SUCCESS or keyboard != gtk.gdk.GRAB_SUCCESS:
            self.__window.grab_remove()
            self.__window.hide()

            if pointer == gtk.gdk.GRAB_SUCCESS:
                gtk.gdk.pointer_ungrab(gtk.get_current_event_time())
            if keyboard == gtk.gdk.GRAB_SUCCESS:
                gtk.gdk.keyboark_ungrab(gtk.get_current_event_time())
    def __scroll(self, widget, ev, hscale):
        adj = self.__adj
        v = hscale.get_value()
        if ev.direction in self.UP: v += adj.step_increment
        else: v -= adj.step_increment
        v = min(adj.upper, max(adj.lower, v))
        hscale.set_value(v)

    def __button(self, widget, ev):
        self.__popup_hide()

    def __key(self, hscale, ev):
        if ev.string in ["\n", "\r", " ", "\x1b"]: # enter, space, escape
            self.__popup_hide()

    def __popup_hide(self):
        self.__window.grab_remove()
        gtk.gdk.pointer_ungrab(gtk.get_current_event_time())
        gtk.gdk.keyboard_ungrab(gtk.get_current_event_time())
        self.__window.hide()
class PopupVSlider(PopupSlider):
    Scale = gtk.VScale
    _req = (-1, 170)
    _adj = gtk.Adjustment(0, 0, 1, 0.05, 0.1, 0)
    UP = [gtk.gdk.SCROLL_UP, gtk.gdk.SCROLL_LEFT]

    def _move_to(self, x, y, w, h, ww, wh, pad=3):
        return ((x + (w - ww)//2), y + h + pad)

class VolumeSlider(PopupVSlider):
        def __init__(self,gst_player):
            i = gtk.image_new_from_icon_name(
               "stock_volume-max", gtk.ICON_SIZE_LARGE_TOOLBAR)
            PopupVSlider.__init__(self, i)
            self.scale.set_update_policy(gtk.UPDATE_CONTINUOUS)

            self.scale.connect('value-changed', self.__volume_changed,gst_player)
            self.scale.set_inverted(True)
            self.scale.set_range(0,1)
            self.get_value = self.scale.get_value
            self.set_value = self.scale.set_value
            volume = float(config.get("setting","volume"))
            self.set_value(volume)
            self.__volume_changed(self.scale,gst_player)
            self.show_all()


        def __volume_changed(self, slider,gst_player):
            val = slider.get_value()
            '''if val == 0: img = stock.VOLUME_OFF
            elif val < 0.33: img = stock.VOLUME_MIN
            elif val < 0.66: img = stock.VOLUME_MED
            else: img = stock.VOLUME_MAX'''

            if val == 0: img = "stock_volume-0"
            elif val < 0.33: img = "stock_volume-min"
            elif val < 0.66: img = "stock_volume-med"
            else: img = "stock_volume-max"

            #self.child.child.set_from_stock(img, gtk.ICON_SIZE_LARGE_TOOLBAR)
            self.child.child.set_from_icon_name(img, gtk.ICON_SIZE_LARGE_TOOLBAR)
            val = (2 ** val) - 1
            gst_player.volume = val
            config.set("setting","volume","%f"%val)
            #player.client.configval_set("output.volume","%d/%d" % (val,val))

