###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###


import string
import os
import urllib,locale
import config
import sre
import time
import gtk
import struct


#Remove it when i finish to clean other code
def normalize_song_dict(dict):
    if not dict.has_key("duration") or dict["duration"]==None:
        dict["duration"]=0
    if not dict.has_key("title") or dict["title"]==None:
        dict["title"]=get_filename(dict["uri"])
    if not dict.has_key("artist") or dict["artist"]==None:
        dict["artist"]=""
    if not dict.has_key("album") or dict["album"]==None:
        dict["album"]=""
    if not dict.has_key("tracknr") or dict["tracknr"]==None:
        dict["tracknr"]=0
    return dict

def escape(str ):
    return string.replace(str,"'","''")

def unescape(str ):
    return string.replace(str,"''","'")

# http://developer.gnome.org/doc/API/2.0/glib/glib-running.html
if "G_FILENAME_ENCODING" in os.environ:
    fscoding = os.environ["G_FILENAME_ENCODING"].split(",")[0]
    if fscoding == "@locale": fscoding = locale.getpreferredencoding()
elif "G_BROKEN_FILENAMES" in os.environ:
    fscoding = locale.getpreferredencoding()
else: fscoding = "utf-8"

def fsdecode(s):
    """Decoding a string according to the filesystem encoding."""
    if isinstance(s, unicode): return s
    else: return decode(s, fscoding)

def fsencode(s):
    """Encode a string according to the filesystem encoding, replacing
    errors."""
    if isinstance(s, str): return s
    else: return s.encode(fscoding, 'replace')

def decode(s, charset="utf-8"):
    """Decode a string; if an error occurs, replace characters and append
    a note to the string."""
    try: return s.decode(charset)
    except UnicodeError:
        return s.decode(charset, "replace") + " " + _("[Invalid Encoding]")

def encode(s, charset="utf-8"):
    """Encode a string; if an error occurs, replace characters and append
    a note to the string."""
    try: return s.encode(charset)
    # FIXME: Can *this* happen?
    except UnicodeError:
        return (s + " " + _("[Invalid Encoding]")).encode(charset, "replace")

def get_protocol(uri):
    protocol = uri[:uri.index("://")+3]
    return protocol

def get_path(uri):
    return uri[uri.index("://")+3:]

def get_ext(uri,complete=True):
    if complete:
        return uri[uri.rindex("."):].lower()
    else:
        return uri[uri.rindex(".")+1:].lower()

def get_filename(uri):
    return uri[uri.rindex("/")+1:]

def uri_to_path(uri):
    return get_path(uri)

def convert_to_uri(uri):
    protocol = get_protocol(uri)
    uri = uri_to_path(uri)
    uri = uri.encode('utf-8')
    uri = urllib.quote(uri)
    uri = protocol+uri
    return uri

def filtre_info_song(str):
    str = str.lower()
    str = str.replace("bo ","").replace("ost ","").replace(" - "," ")
    str = str.replace("cd1","").replace("cd2","").replace("cd 2","").replace("cd 1","")
    str = str.replace("(","").replace(")","").replace("1cd","")
    return str

def url_hook(widget,site):
    website(site)

def website(site):
    site = site.replace("\\", "\\\\").replace("\"", "\\\"")
    for s in (["gnome-open","sensible-browser"] +
              os.environ.get("BROWSER","").split(":")):
        if iscommand(s):
            if "%s" in s:
                s = s.replace("%s", '"' + site + '"')
                s = s.replace("%%", "%")
            else: s += " \"%s\"" % site
            if os.system(s + " &") == 0: return True
    else: return False

def iscommand(s):
    """True si la commande a ete trouve"""
    if s == "" or os.path.sep in s:
        return os.path.exists(s)
    else:
        s = s.split()[0]
        for p in os.environ["PATH"].split(os.path.pathsep):
            p2 = os.path.join(p, s)
            if os.path.exists(p2): return True
        else: return False

def re_esc(str):
    return "".join(map(
        lambda a: (a in "/.^$*+?{,}\\[]|()<>#=!:" and "\\" + a) or a, str))
sre.escape = re_esc


def export_playlist(filename,list_song):
    m3u = "#EXTM3U\n"
    for song in list_song:
        m3u += "#EXTINF:%d,%s"%(song.get_property("duration")/1000,song.sprint("title"))+"\n"
        m3u += song.get_path()+"\n"

    fileout = open(filename, "w")
    fileout.write(m3u)

def import_playlist(filename,force_format=None):
    #FIXME: Use gnomevfs
    list_uri = []
    if get_protocol(filename)=="file://":
        array_line = file(get_path(filename)).readlines()
    else:
        opener = urllib.FancyURLopener()
        f = opener.open(filename)
        array_line = f.read()
        array_line = array_line.split("\n")

    if get_ext(filename) == ".m3u" or force_format==".m3u":
        for line in array_line:
            if not line.startswith("#"):
                list_uri.append(line.replace("\n",""))
    if get_ext(filename) == ".pls" or force_format==".pls":
        for line in array_line:
            if line.startswith("File") or line.startswith("file"):
               list_uri.append(line[:lien.find("=")].replace("\n",""))
    return list_uri

def duration_to_string(value):

    duration = "%02d:%02d" % ((value/60000)%60, (value/1000)%60)
    if value/60000/60>=1:
        duration = "%d:"%(value/60000/60)+duration
    return duration


def time_unix_to_mac(time):
    return time+2082844800
def time_mac_to_unix(time):
    return time-2082844800



